////////////////////////////////////////////////////////////////////////////////
// Jazarsoft MaxMem                                                           //
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// VERSION      : 1.1                                                         //
// AUTHOR       : James Azarja                                                //
// CREATED      : 20 October 2000                                             //
// MODIFIED     : 26 March 2001                                               //
// WEBSITE      : http://www.jazarsoft.com                                    //
// SUPPORT      : support@jazarsoft.com                                       //
// BUG-REPORT   : bugreport@jazarsoft.com                                     //
// COMMENT      : comment@jazarsoft.com                                       //
// LEGAL        : Copyright (C) 2000-2001 Jazarsoft.                          //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// This code may be used and modified by anyone so long as  this header and   //
// copyright  information remains intact.                                     //
//                                                                            //
// The code is provided "as-is" and without warranty of any kind,             //
// expressed, implied or otherwise, including and without limitation, any     //
// warranty of merchantability or fitness for a  particular purpose.         //
//                                                                            //
// In no event shall the author be liable for any special, incidental,        //
// indirect or consequential damages whatsoever (including, without           //
// limitation, damages for loss of profits, business interruption, loss       //
// of information, or any other loss), whether or not advised of the          //
// possibility of damage, and on any theory of liability, arising out of      //
// or in connection with the use or inability to use this software.         //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//To Recompile this program, you need the following component:                //
// TCoolGauge                                                                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, CoolGauge, MaxMem;

type
  TfrmMaxMem = class(TForm)
    MaxMem: TMaxMem;
    cgMemory: TCoolGauge;
    cgProgress: TCoolGauge;
    Label1: TLabel;
    Timer: TTimer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure MaxMemBeforeDefrag(Sender: TObject);
    procedure MaxMemAfterDefrag(Sender: TObject);
    procedure MaxMemProgress(Sender: TObject; Progress: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMaxMem: TfrmMaxMem;

implementation

{$R *.DFM}

procedure TfrmMaxMem.FormCreate(Sender: TObject);
begin
 cgMemory.MaxValue:=MaxMem.TotalMemory;
end;

procedure TfrmMaxMem.TimerTimer(Sender: TObject);
begin
 cgMemory.Progress:=MaxMem.FreeMemory;
 cgMemory.Text:=Format('%d of %d',[cgMemory.Progress,cgMemory.MaxValue]);
 Application.ProcessMessages;
end;

procedure TfrmMaxMem.MaxMemBeforeDefrag(Sender: TObject);
begin
 Timer.Enabled:=False;
 cgProgress.Visible:=True;
 Button3.Visible:=True;
 cgProgress.Progress:=0;
end;

procedure TfrmMaxMem.MaxMemAfterDefrag(Sender: TObject);
begin
 cgProgress.Visible:=False;
 Button3.Visible:=False;
 Timer.Enabled:=True;
end;

procedure TfrmMaxMem.MaxMemProgress(Sender: TObject; Progress: Integer);
begin
 cgProgress.progress:=Progress;
 Application.ProcessMessages;
end;

procedure TfrmMaxMem.Button3Click(Sender: TObject);
begin
  MaxMem.Abort;
end;

procedure TfrmMaxMem.Button1Click(Sender: TObject);
begin
  MaxMem.DefragAll;
end;

procedure TfrmMaxMem.Button2Click(Sender: TObject);
begin
 Close;
end;

end.
